#include <DS3231.h>
#include <Wire.h>
#include <LiquidCrystal.h>
#include <DHT.h>
#include <string.h>

#define NOTE_B0 31
#define NOTE_C1 33
#define NOTE_CS1 35
#define NOTE_D1 37
#define NOTE_DS1 39
#define NOTE_E1 41
#define NOTE_F1 44
#define NOTE_FS1 46
#define NOTE_G1 49
#define NOTE_GS1 52
#define NOTE_A1 55
#define NOTE_AS1 58
#define NOTE_B1 62
#define NOTE_C2 65
#define NOTE_CS2 69
#define NOTE_D2 73
#define NOTE_DS2 78
#define NOTE_E2 82
#define NOTE_F2 87
#define NOTE_FS2 93
#define NOTE_G2 98
#define NOTE_GS2 104
#define NOTE_A2 110
#define NOTE_AS2 117
#define NOTE_B2 123
#define NOTE_C3 131
#define NOTE_CS3 139
#define NOTE_D3 147
#define NOTE_DS3 156
#define NOTE_E3 165
#define NOTE_F3 175
#define NOTE_FS3 185
#define NOTE_G3 196
#define NOTE_GS3 208
#define NOTE_A3 220
#define NOTE_AS3 233
#define NOTE_B3 247
#define NOTE_C4 262
#define NOTE_CS4 277
#define NOTE_D4 294
#define NOTE_DS4 311
#define NOTE_E4 330
#define NOTE_F4 349
#define NOTE_FS4 370
#define NOTE_G4 392
#define NOTE_GS4 415
#define NOTE_A4 440
#define NOTE_AS4 466
#define NOTE_B4 494
#define NOTE_C5 523
#define NOTE_CS5 554
#define NOTE_D5 587
#define NOTE_DS5 622
#define NOTE_E5 659
#define NOTE_F5 698
#define NOTE_FS5 740
#define NOTE_G5 784
#define NOTE_GS5 831
#define NOTE_A5 880
#define NOTE_AS5 932
#define NOTE_B5 988
#define NOTE_C6 1047
#define NOTE_CS6 1109
#define NOTE_D6 1175
#define NOTE_DS6 1245
#define NOTE_E6 1319
#define NOTE_F6 1397
#define NOTE_FS6 1480
#define NOTE_G6 1568
#define NOTE_GS6 1661
#define NOTE_A6 1760
#define NOTE_AS6 1865
#define NOTE_B6 1976
#define NOTE_C7 2093
#define NOTE_CS7 2217
#define NOTE_D7 2349
#define NOTE_DS7 2489
#define NOTE_E7 2637
#define NOTE_F7 2794
#define NOTE_FS7 2960
#define NOTE_G7 3136
#define NOTE_GS7 3322
#define NOTE_A7 3520
#define NOTE_AS7 3729
#define NOTE_B7 3951
#define NOTE_C8 4186
#define NOTE_CS8 4435
#define NOTE_D8 4699
#define NOTE_DS8 4978

///* Modulul Bluetooth */
//SoftwareSerial BTSerial(0, 1);

/* Senzor temperatura - tip */
#define DHTTYPE DHT22

/* Initializez display-ul */
LiquidCrystal lcd(12,11,9,8,7,6);

/* Initializez modulul RTC */
DS3231 rtc(SDA, SCL);

/* Setez cele 4 butoane */
const int button_1 = 2;
const int button_2 = 3;
const int button_3 = 4;
const int button_4 = 10;

/* Buzzer */
int piezo = 5; 

/* Setez ledurile */
int greenPin = A2;
int bluePin = A1;

/* Senzor de sunet */
int soundSensor = A0;

/* Senzor temperatura si umiditate */
int dhtpin = 13;

/* Initializez senzorul de temperatura si umiditate */
DHT dht(dhtpin, DHTTYPE);
Time  t;

int button1NoPush = 0;   
int button2NoPush = 0;   
int button3NoPush = 0;   
int button4NoPush = 0;
int up_buttonState = 0;
int up_lastbutton_1State = 0;
int up_lastbutton_2State = 0;
int up_lastbutton_3State = 0;
int up_lastbutton_4State = 0;  
int soundCounter = 1;
bool button_pressed = false;
int alarm_hour=0;
int alarm_sec=0;
int alarm_min=0;
//int pirPin = 10;
int motion, sensorValue;

int melody[] = {
  NOTE_FS5, NOTE_FS5, NOTE_D5, NOTE_B4, NOTE_B4, NOTE_E5, 
  NOTE_E5, NOTE_E5, NOTE_GS5, NOTE_GS5, NOTE_A5, NOTE_B5, 
  NOTE_A5, NOTE_A5, NOTE_A5, NOTE_E5, NOTE_D5, NOTE_FS5, 
  NOTE_FS5, NOTE_FS5, NOTE_E5, NOTE_E5, NOTE_FS5, NOTE_E5
};

// The note duration, 8 = 8th note, 4 = quarter note, etc.
int durations[] = {
  8, 8, 8, 4, 4, 4, 
  4, 5, 8, 8, 8, 8, 
  8, 8, 8, 4, 4, 4, 
  4, 5, 8, 8, 8, 8
};
// determine the length of the arrays to use in the loop iteration
int songLength = sizeof(melody)/sizeof(melody[0]);

void setup(){
  /* LCD */
  lcd.begin(16,2);
  /* RTC */
  rtc.begin();
  /* Senzor temp/umiditate */
  dht.begin();
  /* Leduri */
  pinMode(greenPin, OUTPUT);
  pinMode(bluePin, OUTPUT);
  /* Serial monitor */
  Serial.begin(9600);

  pinMode(button_1, INPUT);
  pinMode(button_2, INPUT);
  pinMode(button_3, INPUT);
  pinMode(button_4, INPUT);
  pinMode (soundSensor, INPUT);
  //pinMode(pirPin, INPUT);
  pinMode(piezo, OUTPUT);
 }


/* Contorizez apasarea butoanelor */
void fbuttonState(int *up_lastButtonState, int *buttonNoPush, int button){
   up_buttonState = digitalRead(button);
     if (up_buttonState != (*up_lastButtonState) ){
        if (up_buttonState == LOW) {
          button_pressed = true;
          (*buttonNoPush)++;
          lcd.clear();
        }
     }
      (*up_lastButtonState) = up_buttonState;
}

void isButtonPushed() {
  fbuttonState(&up_lastbutton_1State, &button1NoPush, button_1);
  fbuttonState(&up_lastbutton_2State, &button2NoPush, button_2);
  fbuttonState(&up_lastbutton_3State, &button3NoPush, button_3);
  fbuttonState(&up_lastbutton_4State, &button4NoPush, button_4);
}

void setAlarm() {
  /* Dau caractere in Serial monitor si cresc/scad valoarea orelor,minutelor si secundelor */
  if(Serial.available()) {
      char data = Serial.read();
      if (data == '1') {
        if (alarm_hour == 23)
          alarm_hour = 0;
        else
          alarm_hour++;
      }
      if (data == '2') {
        if (alarm_hour == 0)
          alarm_hour = 24;
        alarm_hour--;
      }
      if (data == '3') {
        if (alarm_min == 59)
          alarm_min = 0;
        else
          alarm_min++;
      }
      if (data == '4') {
        if (alarm_min == 0)
          alarm_min = 60;
        alarm_min--;
      }
      if (data == '5') {
        if (alarm_sec == 0)
          alarm_sec = 60;
        alarm_sec++;
      }
      if (data == '6') {
        if(alarm_sec == 0)
          alarm_sec = 60;
        alarm_sec--;
      }
      if(button1NoPush == HIGH) {
        lcd.clear();
        lcd.print("Se salveaza...");
        delay(700);
        lcd.clear();
      }
    }
}

void play() {
  for (int thisNote = 0; thisNote < songLength; thisNote++){
    int duration = 1000/ durations[thisNote];
    tone(piezo, melody[thisNote], duration);
    int pause = duration * 1.3;
    delay(pause);
    noTone(piezo);
  }
}

void loop(){
  /* Setez cursorul (stanga sus) */
  lcd.setCursor(0, 0);
  char *data,*ora,*zi;
  int ring = 0;

  /* Citesc timpul de la RTC */
  t = rtc.getTime();

  /* Citesc umiditate/temp */
  float hum = dht.readHumidity();
  float temp = dht.readTemperature();

  /* Senzor sunet */
  sensorValue = digitalRead (soundSensor);                                                     
  if (sensorValue == 1)                                    
  {
    lcd.clear();
    soundCounter++;
  }

  /* Verific butoanele */
  isButtonPushed();


/* Daca ecranul e pornit, pot naviga intre pagini */ 
if(soundCounter % 2 == 1){
  
  if (t.hour == alarm_hour && t.min == alarm_min && t.sec == alarm_sec) {
    ring = 1;
    play(); 
    alarm_hour = 0;
    alarm_min = 0;
    alarm_sec = 0;
  } 
    if (temp >= 30) {
      digitalWrite(greenPin, HIGH);
      digitalWrite(bluePin, LOW);
    } else {
      digitalWrite(greenPin, LOW);
      digitalWrite(bluePin, HIGH);
    }

  /* Ma plimb intre ecrane cu butonul 1 */
  if(button1NoPush == 0){
    lcd.print("Date: ");
    if(t.date < 10)
      lcd.print("0");
    lcd.print(t.date);
    lcd.print("/");
    if(t.mon < 10)
      lcd.print("0");
    lcd.print(t.mon);
    lcd.print("/");
    lcd.print(t.year);

    /* Modific ziua, luna, anul */
    if(button2NoPush == 1){
      lcd.setCursor(7,1);
      lcd.print("-");
      if(button3NoPush == 32)
        button3NoPush = 0;
      rtc.setDate(button3NoPush,t.mon,t.year);
    }
    if(button2NoPush == 2){
      lcd.setCursor(10,1);
      lcd.print("-");
      if(button3NoPush == 13)
        button3NoPush = 0;
      rtc.setDate(t.date,button3NoPush,t.year);
    }
  
    if(button2NoPush == 3){
      lcd.setCursor(13,1);
      lcd.print("-");
      if(button3NoPush == 0)
        button3NoPush = 2000;
      rtc.setDate(t.date,t.mon,button3NoPush);
    }
  
    if(button2NoPush == 4){
      button2NoPush = 1;
    Serial.println("Alo da?");
    }
    rtc.setDOW();
  }

  /* Salvez modificarile facute */
  if(button1NoPush == 1){
    if(button2NoPush != 0){
      lcd.clear();
      lcd.print("Saving...");
      delay(700);
      lcd.clear();
      button2NoPush = 0;
      button3NoPush = 0;
      button1NoPush = 0;
    }
    else{
      button1NoPush = 2;
    }
  }
  
  /* Afisez ziua din saptamana */
  if(button1NoPush == 2){
    lcd.print("Day: ");
    if(t.dow == 1)
    lcd.print("Monday");
    if(t.dow == 2)
    lcd.print("Tuesday");
    if(t.dow == 3)
    lcd.print("Wednesday");
    if(t.dow == 4)
    lcd.print("Thursday");
    if(t.dow == 5)
    lcd.print("Friday");
    if(t.dow == 6)
    lcd.print("Saturday");
    if(t.dow == 7)
    lcd.print("Sunday");
  }

  /* Modific ora */
  if(button1NoPush == 3){
    lcd.print("Hour:");
    if(button4NoPush == 2)
      button4NoPush = 0;
    if(button4NoPush == 0){ 
    if(t.hour < 10)
    lcd.print("0");
    lcd.print(t.hour);
    lcd.print(":");
    if(t.min < 10)
    lcd.print("0");
    lcd.print(t.min);
    lcd.print(":");
    if(t.sec < 10)
    lcd.print("0");
    lcd.print(t.sec);
    }
  
    if(button4NoPush == 1){ 
      if(t.hour < 10)
        lcd.print("0");
      if(t.hour > 11){
        if((t.hour - 12) < 10)
        lcd.print("0");
        lcd.print(t.hour - 12);
      }
      else
      lcd.print(t.hour);
      lcd.print(":");
      if(t.min < 10)
        lcd.print("0");
      lcd.print(t.min);
      lcd.print(":");
      if(t.sec < 10)
        lcd.print("0");
      lcd.print(t.sec);
      if(t.hour < 12)
        lcd.print(" AM");
      else
        lcd.print(" PM");
    }
  
    if((button2NoPush == 4) && (button4NoPush == 0)){
      button2NoPush = 1;
    }
    
    if((button2NoPush == 5) && (button4NoPush == 1)){
      button2NoPush = 1;
    }

     /* Verific daca ora e in format PM (24 ore) */
    if(button2NoPush == 1){
      lcd.setCursor(6,1);
      lcd.print("-");
      if(button4NoPush == 0){
      if(button3NoPush == 25)
      button3NoPush = 1;
      if(button3NoPush > 0)
      rtc.setTime(button3NoPush,t.min,t.sec);
    }

    /* Verific daca ora e in format AM (12 ore) */
    if(button4NoPush == 1){
      if(button3NoPush == 13)
      button3NoPush = 1;
      if(button3NoPush > 0)
      rtc.setTime(button3NoPush,t.min,t.sec);
    }
    }
     /* Minutele */
    if(button2NoPush == 2){
      lcd.setCursor(9,1);
      lcd.print("-");
      if(button3NoPush == 61)
      button3NoPush = 1;
      if(button3NoPush > 0)
      rtc.setTime(t.hour,button3NoPush,t.sec);
    }

    /* Secundele */
    if(button2NoPush == 3){
      lcd.setCursor(12,1);
      lcd.print("-");
      if(button3NoPush == 61)
      button3NoPush = 1;
      if(button3NoPush > 0)
      rtc.setTime(t.hour,t.min,button3NoPush);
    }
  
    if(button2NoPush == 4){
      lcd.setCursor(14,1);
      lcd.print("-");
      if(button3NoPush == 3)
      button3NoPush = 1;
      if(button3NoPush == 1){
        if(t.hour < 12)
        rtc.setTime(t.hour + 12,t.min,t.sec);
        else
        rtc.setTime(t.hour-12,t.min,t.sec);
        button3NoPush = 2;
      }
    }
  }

  /* Pagina de salvare */
  if(button1NoPush == 4){
    if(button2NoPush != 0){
      lcd.clear();
      lcd.print("Saving...");
      delay(700);
      lcd.clear();
      button2NoPush = 0;
      button3NoPush = 0;
      button1NoPush = 3;
    }
    else{
      button1NoPush = 5;
    }
  }

  /* Afisez temperatura si umiditatea */
  if(button1NoPush == 5){
  lcd.print("Temp: ");
  lcd.print(temp);
  lcd.print(" C");
  lcd.setCursor(0,1);
  lcd.print("Hum: ");
  lcd.print(hum);
  lcd.print(" %");
  }

  /* Revin la prima pagina */
   if(button1NoPush == 6){
    lcd.print("Alarma");
    lcd.setCursor(0,1);
    if(alarm_hour < 10)
    lcd.print("0");
    lcd.print(alarm_hour);
    lcd.print(":");
    if(alarm_min < 10)
    lcd.print("0");
    lcd.print(alarm_min);
    lcd.print(":");
    if(alarm_sec < 10)
    lcd.print("0");
    lcd.print(alarm_sec);
    setAlarm();
  }
  if(button1NoPush == 7){
    button1NoPush = 0;
  }
}

/* Stand by */
else{
  lcd.print("Have a good day!");
}
}
